# coding: utf-8

"""
    AI Decision Protocol

    AI Decision Protocol Specification

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, validator
from aitp.stubs.models.decision import Decision
from aitp.stubs.models.request_decision import RequestDecision
from typing import Union, Any, List, TYPE_CHECKING
from pydantic import StrictStr, Field

DECISIONPROTOCOL_ANY_OF_SCHEMAS = ["Decision", "RequestDecision"]

class DecisionProtocol(BaseModel):
    """
    DecisionProtocol
    """

    # data type: Decision
    anyof_schema_1_validator: Optional[Decision] = None
    # data type: RequestDecision
    anyof_schema_2_validator: Optional[RequestDecision] = None
    if TYPE_CHECKING:
        actual_instance: Union[Decision, RequestDecision]
    else:
        actual_instance: Any
    any_of_schemas: List[str] = Field(DECISIONPROTOCOL_ANY_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator('actual_instance')
    def actual_instance_must_validate_anyof(cls, v):
        instance = DecisionProtocol.construct()
        error_messages = []
        # validate data type: Decision
        if not isinstance(v, Decision):
            error_messages.append(f"Error! Input type `{type(v)}` is not `Decision`")
        else:
            return v

        # validate data type: RequestDecision
        if not isinstance(v, RequestDecision):
            error_messages.append(f"Error! Input type `{type(v)}` is not `RequestDecision`")
        else:
            return v

        if error_messages:
            # no match
            raise ValueError("No match found when setting the actual_instance in DecisionProtocol with anyOf schemas: Decision, RequestDecision. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> DecisionProtocol:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> DecisionProtocol:
        """Returns the object represented by the json string"""
        instance = DecisionProtocol.construct()
        error_messages = []
        # anyof_schema_1_validator: Optional[Decision] = None
        try:
            instance.actual_instance = Decision.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_2_validator: Optional[RequestDecision] = None
        try:
            instance.actual_instance = RequestDecision.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))

        if error_messages:
            # no match
            raise ValueError("No match found when deserializing the JSON string into DecisionProtocol with anyOf schemas: Decision, RequestDecision. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())


