# coding: utf-8

"""
    AI Decision Protocol

    AI Decision Protocol Specification

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr, validator

class PaymentPlan(BaseModel):
    """
    PaymentPlan
    """
    plan_id: StrictStr = Field(...)
    plan_type: StrictStr = Field(...)
    amount: Union[StrictFloat, StrictInt] = Field(...)
    currency: StrictStr = Field(...)
    additional_properties: Dict[str, Any] = {}
    __properties = ["plan_id", "plan_type", "amount", "currency"]

    @validator('plan_type')
    def plan_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('one-time',):
            raise ValueError("must be one of enum values ('one-time')")
        return value

    @validator('currency')
    def currency_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('USD',):
            raise ValueError("must be one of enum values ('USD')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PaymentPlan:
        """Create an instance of PaymentPlan from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "additional_properties"
                          },
                          exclude_none=True)
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PaymentPlan:
        """Create an instance of PaymentPlan from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PaymentPlan.parse_obj(obj)

        _obj = PaymentPlan.parse_obj({
            "plan_id": obj.get("plan_id"),
            "plan_type": obj.get("plan_type") if obj.get("plan_type") is not None else 'one-time',
            "amount": obj.get("amount"),
            "currency": obj.get("currency")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


